#include <glide.h>

typedef struct grVertex_type 
{	FxFloat x,y;
	FxFloat z;
	FxFloat r,g,b;
	FxFloat u,v;
} grVertex, *grVertex_ptr;

typedef struct D3Vertex_type 
{	FxFloat x,y,z;
	FxFloat r,g,b;
} D3Vertex, *D3Vertex_ptr;

typedef struct Normal_type 
{	FxFloat x,y,z;
} Normal, *Normal_ptr;

typedef struct Face_type 
{	int  a,b,c;
	bool Clip;
} Face, *Face_ptr;

typedef struct D3Object_type
{	bool			Clip;			// Object Clip Flag
	Normal			World_Pos;		// Object World Position
	int				NumVertices;	// Number of Vertices
	int				NumFaces;		// Number of Faces
	D3Vertex_ptr	Vertices_local;	// Local Coordinate information
	D3Vertex_ptr	Vertices_world;	// World Coordinate information
	grVertex_ptr	Vertices_screen;
	Normal_ptr		Vertices_normalStat;
	Face_ptr		Faces;				
	D3Vertex		Spotlight;
} D3Object, *D3Object_ptr;

void SetVertexLayout()
{	grVertexLayout(GR_PARAM_XY, 0,  GR_PARAM_ENABLE);
	grVertexLayout(GR_PARAM_Q,  8,  GR_PARAM_ENABLE);
	grVertexLayout(GR_PARAM_RGB,12, GR_PARAM_ENABLE);
	grVertexLayout(GR_PARAM_ST0,24, GR_PARAM_ENABLE);

}


