#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define ReadTil(string) while (strcmp(line, string)) fscanf(fp, "%s",line);

int  LoadAscFile(char *filename, D3Object_ptr Object, float scale);
void PrecomputeVertexNormals(D3Object_ptr Object);



int LoadAscFile(char *filename, D3Object_ptr Object, float scale)
{	FILE  *fp;
	char  line[80];
	char  trash[20];
	D3Vertex_ptr D3VertexList = NULL;
	Face_ptr     Faces		  = NULL;
	float x,y,z;

	// Open the file
	if ((fp=fopen(filename,"r" ))==NULL)					
	{	printf("Error opening file: Can't find file\n");
		return(0);
	}
	
	// Skip 3 lines and get the fourth line
	fgets(line,80,fp);fgets(line,80,fp);
	fgets(line,80,fp);fgets(line,80,fp);

	// read number of vertices and number of faces
	sscanf(line,"Tri-mesh, Vertices: %d Faces: %d", &Object->NumVertices, &Object->NumFaces);
	// And reserve memory for this object
	D3VertexList = (D3Vertex_ptr) calloc(Object->NumVertices, sizeof(D3Vertex) );
	Faces		 = (Face_ptr)     calloc(Object->NumFaces, sizeof(Face));

	// Skip another line. Now read all the value's of the vertices into our Object
	// This function also scales the vertices by a factor 'SCALE' 
	fgets(line,80,fp);								
	for (int count=0; count<Object->NumVertices; count++)
	{	ReadTil("Vertex");
		fgets(line,80,fp);
		
		sscanf(line,"%s X: %f Y: %f Z: %f", &trash, &x, &y, &z);
		D3VertexList[count].x=x * scale;
		D3VertexList[count].y=z * scale;
		D3VertexList[count].z=y * scale;
	}
	// Read all faces, etc...
	for (count=0; count<Object->NumFaces; count++)
	{	ReadTil("Face");
		fgets(line,80,fp);
		sscanf(line,"%s A:%d B:%d C:%d",&trash, &Faces[count].a, &Faces[count].b, &Faces[count].c);
	}

	Object->Vertices_local      = D3VertexList;
	Object->Faces				= Faces;
	Object->Vertices_world      = (D3Vertex_ptr) calloc(Object->NumVertices, sizeof(D3Vertex) );
	Object->Vertices_screen     = (grVertex_ptr) calloc(Object->NumVertices, sizeof(grVertex) );
	Object->Vertices_normalStat = (Normal_ptr)   calloc(Object->NumVertices, sizeof(Normal)   );
	
	PrecomputeVertexNormals(Object); 

	fclose(fp);
	return(1);
}




void PrecomputeVertexNormals(D3Object_ptr Object)
{	// This function is used by the LoadAscFile function. It precomputes all vertexnormals
	Normal a,b;
	int    deler;
	float  x,y,z,length;	
	
	// Take a vertex
	for (int count=0;count<Object->NumVertices; count++)
	{	deler = 0; // deler is used as to divide x, y and z by the number of faces which share the vertex
		// Go though all faces to see which faces have this vertex in common
		for (int count2=0;count2<Object->NumFaces; count2++)
		{	// Now if if the face shares the vertex -- compute face normal and add its x component to x, its y to y and its z to z
			// also increase deler.
			if(	Object->Faces[count2].a==count || Object->Faces[count2].b==count || Object->Faces[count2].c==count   )
			{	deler++;
				a.x = Object->Vertices_local[Object->Faces[count2].c].x - Object->Vertices_local[Object->Faces[count2].a].x;
				a.y = Object->Vertices_local[Object->Faces[count2].c].y - Object->Vertices_local[Object->Faces[count2].a].y;
				a.z = Object->Vertices_local[Object->Faces[count2].c].z - Object->Vertices_local[Object->Faces[count2].a].z;
				b.x = Object->Vertices_local[Object->Faces[count2].b].x - Object->Vertices_local[Object->Faces[count2].a].x;
				b.y = Object->Vertices_local[Object->Faces[count2].b].y - Object->Vertices_local[Object->Faces[count2].a].y;
				b.z = Object->Vertices_local[Object->Faces[count2].b].z - Object->Vertices_local[Object->Faces[count2].a].z;	
				
				x = x + ((b.y*a.z)-(b.z*a.y));	
				y = y + ((b.z*a.x)-(b.x*a.z));
				z = z + ((b.x*a.y)-(b.y*a.x));
			}	
		}
		if (deler != 0)
		{	Object->Vertices_normalStat[count].x = x / deler; 
			Object->Vertices_normalStat[count].y = y / deler; 
			Object->Vertices_normalStat[count].z = z / deler; 
		} 
		// Normalize the length to 1 to save dividing time in our (realtime) routine as dividing by 1 is not needed !
		length = sqrt((Object->Vertices_normalStat[count].x*Object->Vertices_normalStat[count].x) + 
					  (Object->Vertices_normalStat[count].y*Object->Vertices_normalStat[count].y) + 
					  (Object->Vertices_normalStat[count].z*Object->Vertices_normalStat[count].z) );
		
		Object->Vertices_normalStat[count].x=Object->Vertices_normalStat[count].x / length;
		Object->Vertices_normalStat[count].y=Object->Vertices_normalStat[count].y / length;
		Object->Vertices_normalStat[count].z=Object->Vertices_normalStat[count].z / length;
		
		x=0;y=0;z=0;
	}
}


