
// 3dfx Programming Secrets - demo 1

// This program just initialises glide and sets 3dfx
// videomode 640*480.

#include <glide.h>

void main(void)
{
  GrHwConfiguration HwConfig;

  // Initialise Glide - this function MUST be called
  // before anything else is done with Glide:
  grGlideInit();

  // Check for precence of 3dfx hardware:
  if ((grSstQueryHardware(&HwConfig)) == FXFALSE)
  {
        printf("Error! No 3dfx hardware!");
		exit(1);
  }
  // found 3dfx hardware!
  // select first voodoo board in system - this means you
  // can use different boards in your computer connected to
  // different monitors from the same program! Glide
  // only works with the current board selected from
  // the grSstSelect function.
  grSstSelect( 0 );

  // sets 3dfx videomode with some parameters
  grSstWinOpen( 0,
               GR_RESOLUTION_640x480,
               GR_REFRESH_60Hz,
               GR_COLORFORMAT_RGBA,
               GR_ORIGIN_UPPER_LEFT,
               2, 1);

  // clears the backbuffer red
  grBufferClear( 0xff000000, 0, GR_WDEPTHVALUE_FARTHEST );

  // swaps the backbuffer to the frontbuffer - makes the
  // red screen visible!
  grBufferSwap(1);

  // wait for a keystroke:
  getch();

  // shut down glide and return to normal videomode:
  grGlideShutdown();

}
