
#include <windows.h>
#include <glide3.h>

// Returns 1 if success and 0 if failure.
int LoadProcAddresses(void)
{
  HINSTANCE g3i;

  g3i = LoadLibrary("glide3x");

  if (g3i == NULL)
    return 0;

  // rendering functions:

  grDrawPoint = (void*)GetProcAddress(g3i,"_grDrawPoint@4");
  if (grDrawPoint == NULL)
    return 0;
  grDrawLine =  (void*)GetProcAddress(g3i,"_grDrawLine@8");
  if (grDrawLine == NULL)
    return 0;
  grDrawTriangle = (void*)GetProcAddress(g3i,"_grDrawTriangle@12");
  if (grDrawTriangle == NULL)
    return 0;
  grVertexLayout = (void*)GetProcAddress(g3i,"_grVertexLayout@12");
  if (grVertexLayout == NULL)
    return 0;
  grDrawVertexArray = (void*)GetProcAddress(g3i,"_grDrawVertexArray@12");
  if (grDrawVertexArray == NULL)
    return 0;
  grDrawVertexArrayContiguous = (void*)GetProcAddress(g3i,"_grDrawVertexArrayContiguous@16");
  if (grDrawVertexArrayContiguous == NULL)
    return 0;

  // Antialiasing functions

  grAADrawTriangle = (void*)GetProcAddress(g3i,"_grAADrawTriangle@24");
  if (grAADrawTriangle == NULL)
    return 0;

  // buffer management

  grBufferClear = (void*)GetProcAddress(g3i,"_grBufferClear@12");
  if (grBufferClear == NULL)
    return 0;
  grBufferSwap = (void*)GetProcAddress(g3i,"_grBufferSwap@4");
  if (grBufferSwap == NULL)
    return 0;
  grRenderBuffer = (void*)GetProcAddress(g3i,"_grRenderBuffer@4");
  if (grRenderBuffer== NULL)
    return 0;

  // error management

  grErrorSetCallback = (void*)GetProcAddress(g3i,"_grErrorSetCallback@4");
  if (grErrorSetCallback == NULL)
    return 0;

  // SST routines

  grFinish = (void*)GetProcAddress(g3i,"_grFinish@0");
  if (grFinish == NULL)
    return 0;
  grFlush  = (void*)GetProcAddress(g3i,"_grFlush@0");
  if (grFlush== NULL)
    return 0;
  grSstWinOpen = (void*)GetProcAddress(g3i,"_grSstWinOpen@28");
  if (grSstWinOpen == NULL)
    return 0;
  grSstWinClose = (void*)GetProcAddress(g3i,"_grSstWinClose@4");
  if (grSstWinClose == NULL)
    return 0;
  grSelectContext = (void*)GetProcAddress(g3i,"_grSelectContext@4");
  if (grSelectContext == NULL)
    return 0;
  grSstOrigin = (void*)GetProcAddress(g3i,"_grSstOrigin@4");
  if (grSstOrigin == NULL)
    return 0;
  grSstSelect = (void*)GetProcAddress(g3i,"_grSstSelect@4");
  if (grSstSelect == NULL)
    return 0;

  // Glide configuration and special effect maintainance functions

  grAlphaBlendFunction = (void*)GetProcAddress(g3i,"_grAlphaBlendFunction@16");
  if (grAlphaBlendFunction == NULL)
    return 0;
  grAlphaCombine = (void*)GetProcAddress(g3i,"_grAlphaCombine@20");
  if (grAlphaCombine == NULL)
    return 0;
  grAlphaControlsITRGBLighting = (void*)GetProcAddress(g3i,"_grAlphaControlsITRGBLighting@4");
  if (grAlphaControlsITRGBLighting == NULL)
    return 0;
  grAlphaTestFunction = (void*)GetProcAddress(g3i,"_grAlphaTestFunction@4");
  if (grAlphaTestFunction == NULL)
    return 0;
  grAlphaTestReferenceValue = (void*)GetProcAddress(g3i,"_grAlphaTestReferenceValue@4");
  if (grAlphaTestReferenceValue == NULL)
    return 0;
  grChromakeyMode = (void*)GetProcAddress(g3i,"_grChromakeyMode@4");
  if (grChromakeyMode == NULL)
    return 0;
  grChromakeyValue = (void*)GetProcAddress(g3i,"_grChromakeyValue@4");
  if (grChromakeyValue == NULL)
    return 0;
  grClipWindow = (void*)GetProcAddress(g3i,"_grClipWindow@16");
  if (grClipWindow == NULL)
    return 0;
  grColorCombine = (void*)GetProcAddress(g3i,"_grColorCombine@20");
  if (grColorCombine == NULL)
    return 0;
  grColorMask = (void*)GetProcAddress(g3i,"_grColorMask@8");
  if (grColorMask == NULL)
    return 0;
  grCullMode = (void*)GetProcAddress(g3i,"_grCullMode@4");
  if (grCullMode == NULL)
    return 0;
  grConstantColorValue = (void*)GetProcAddress(g3i,"_grConstantColorValue@4");
  if (grConstantColorValue == NULL)
    return 0;
  grDepthBiasLevel = (void*)GetProcAddress(g3i,"_grDepthBiasLevel@4");
  if (grDepthBiasLevel == NULL)
    return 0;
  grDepthBufferFunction = (void*)GetProcAddress(g3i,"_grDepthBufferFunction@4");
  if (grDepthBufferFunction == NULL)
    return 0;
  grDepthBufferMode = (void*)GetProcAddress(g3i,"_grDepthBufferMode@4");
  if (grDepthBufferMode == NULL)
    return 0;
  grDepthMask = (void*)GetProcAddress(g3i,"_grDepthMask@4");
  if (grDepthMask == NULL)
    return 0;
  grDisableAllEffects = (void*)GetProcAddress(g3i,"_grDisableAllEffects@0");
  if (grDisableAllEffects == NULL)
    return 0;
  grDitherMode = (void*)GetProcAddress(g3i,"_grDitherMode@4");
  if (grDitherMode == NULL)
    return 0;
  grFogColorValue = (void*)GetProcAddress(g3i,"_grFogColorValue@4");
  if (grFogColorValue == NULL)
    return 0;
  grFogMode = (void*)GetProcAddress(g3i,"_grFogMode@4");
  if (grFogMode == NULL)
    return 0;
  grFogTable = (void*)GetProcAddress(g3i,"_grFogTable@4");
  if (grFogTable == NULL)
    return 0;
  grLoadGammaTable = (void*)GetProcAddress(g3i,"_grLoadGammaTable@16");
  if (grLoadGammaTable == NULL)
    return 0;
  grSplash = (void*)GetProcAddress(g3i,"_grSplash@20");
  if (grSplash == NULL)
    return 0;
  grGet = (void*)GetProcAddress(g3i,"_grGet@12");
  if (grGet == NULL)
    return 0;
  grGetString = (void*)GetProcAddress(g3i,"_grGetString@4");
  if (grGetString == NULL)
    return 0;
  grQueryResolutions = (void*)GetProcAddress(g3i,"_grQueryResolutions@8");
  if (grQueryResolutions == NULL)
    return 0;
  grReset = (void*)GetProcAddress(g3i,"_grReset@4");
  if (grReset == NULL)
    return 0;
  grGetProcAddress = (void*)GetProcAddress(g3i,"_grGetProcAddress@4");
  if (grGetProcAddress == NULL)
    return 0;
  grEnable = (void*)GetProcAddress(g3i,"_grEnable@4");
  if (grEnable == NULL)
    return 0;
  grDisable = (void*)GetProcAddress(g3i,"_grDisable@4");
  if (grDisable == NULL)
    return 0;
  grCoordinateSpace = (void*)GetProcAddress(g3i,"_grCoordinateSpace@4");
  if (grCoordinateSpace == NULL)
    return 0;
  grDepthRange = (void*)GetProcAddress(g3i,"_grDepthRange@8");
  if (grDepthRange == NULL)
    return 0;
  grViewport = (void*)GetProcAddress(g3i,"_grViewport@16");
  if (grViewport == NULL)
    return 0;

  // Texture mapping control functions

  grTexCalcMemRequired = (void*)GetProcAddress(g3i,"_grTexCalcMemRequired@16");
  if (grTexCalcMemRequired == NULL)
    return 0;
  grTexTextureMemRequired = (void*)GetProcAddress(g3i,"_grTexTextureMemRequired@8");
  if (grTexTextureMemRequired == NULL)
    return 0;
  grTexMinAddress = (void*)GetProcAddress(g3i,"_grTexMinAddress@4");
  if (grTexMinAddress == NULL)
    return 0;
  grTexMaxAddress = (void*)GetProcAddress(g3i,"_grTexMaxAddress@4");
  if (grTexMaxAddress == NULL)
    return 0;
  grTexNCCTable = (void*)GetProcAddress(g3i,"_grTexNCCTable@4");
  if (grTexNCCTable == NULL)
    return 0;
  grTexSource = (void*)GetProcAddress(g3i,"_grTexSource@16");
  if (grTexSource == NULL)
    return 0;
  grTexClampMode = (void*)GetProcAddress(g3i,"_grTexClampMode@12");
  if (grTexClampMode == NULL)
    return 0;
  grTexCombine = (void*)GetProcAddress(g3i,"_grTexCombine@28");
  if (grTexCombine == NULL)
    return 0;
  grTexDetailControl = (void*)GetProcAddress(g3i,"_grTexDetailControl@16");
  if (grTexDetailControl == NULL)
    return 0;
  grTexFilterMode = (void*)GetProcAddress(g3i,"_grTexFilterMode@12");
  if (grTexFilterMode == NULL)
    return 0;
  grTexLodBiasValue = (void*)GetProcAddress(g3i,"_grTexLodBiasValue@8");
  if (grTexLodBiasValue == NULL)
    return 0;
  grTexDownloadMipMap = (void*)GetProcAddress(g3i,"_grTexDownloadMipMap@16");
  if (grTexDownloadMipMap == NULL)
    return 0;
  grTexDownloadMipMapLevel = (void*)GetProcAddress(g3i,"_grTexDownloadMipMapLevel@32");
  if (grTexDownloadMipMapLevel == NULL)
    return 0;
  grTexDownloadMipMapLevelPartial = (void*)GetProcAddress(g3i,"_grTexDownloadMipMapLevelPartial@40");
  if (grTexDownloadMipMapLevelPartial == NULL)
    return 0;
  grTexDownloadTable = (void*)GetProcAddress(g3i,"_grTexDownloadTable@8");
  if (grTexDownloadTable== NULL)
    return 0;
  grTexDownloadTablePartial = (void*)GetProcAddress(g3i,"_grTexDownloadTablePartial@16");
  if (grTexDownloadTablePartial == NULL)
    return 0;
  grTexMipMapMode = (void*)GetProcAddress(g3i,"_grTexMipMapMode@12");
  if (grTexMipMapMode == NULL)
    return 0;
  grTexMultibase = (void*)GetProcAddress(g3i,"_grTexMultibase@8");
  if (grTexMultibase == NULL)
    return 0;
  grTexMultibaseAddress = (void*)GetProcAddress(g3i,"_grTexMultibaseAddress@20");
  if (grTexMultibaseAddress == NULL)
    return 0;

  // Linear frame buffer functions

  grLfbLock = (void*)GetProcAddress(g3i,"_grLfbLock@24");
  if (grLfbLock == NULL)
    return 0;
  grLfbUnlock = (void*)GetProcAddress(g3i,"_grLfbUnlock@8");
  if (grLfbUnlock == NULL)
    return 0;
  grLfbConstantAlpha = (void*)GetProcAddress(g3i,"_grLfbConstantAlpha@4");
  if (grLfbConstantAlpha == NULL)
    return 0;
  grLfbConstantDepth = (void*)GetProcAddress(g3i,"_grLfbConstantDepth@4");
  if (grLfbConstantDepth == NULL)
    return 0;

  grLfbWriteColorSwizzle = (void*)GetProcAddress(g3i,"_grLfbWriteColorSwizzle@8");
  if (grLfbWriteColorSwizzle == NULL)
    return 0;
  grLfbWriteColorFormat = (void*)GetProcAddress(g3i,"_grLfbWriteColorFormat@4");
  if (grLfbWriteColorFormat == NULL)
    return 0;

  grLfbWriteRegion = (void*)GetProcAddress(g3i,"_grLfbWriteRegion@36");
  if (grLfbWriteRegion == NULL)
    return 0;


  grLfbReadRegion = (void*)GetProcAddress(g3i,"_grLfbReadRegion@28");
  if (grLfbReadRegion == NULL)
    return 0;

  // Glide management functions

  grGlideInit = (void*)GetProcAddress(g3i,"_grGlideInit@0");
  if (grGlideInit == NULL)
    return 0;
  grGlideShutdown = (void*)GetProcAddress(g3i,"_grGlideShutdown@0");
  if (grGlideShutdown == NULL)
    return 0;
  grGlideGetState = (void*)GetProcAddress(g3i,"_grGlideGetState@4");
  if (grGlideGetState == NULL)
    return 0;
  grGlideSetState = (void*)GetProcAddress(g3i,"_grGlideSetState@4");
  if (grGlideSetState == NULL)
    return 0;
  grGlideGetVertexLayout = (void*)GetProcAddress(g3i,"_grGlideGetVertexLayout@4");
  if (grGlideGetVertexLayout == NULL)
    return 0;
  grGlideSetVertexLayout = (void*)GetProcAddress(g3i,"_grGlideSetVertexLayout@4");
  if (grGlideSetVertexLayout == NULL)
    return 0;

  // Gamma functions


  // Fog stuff

  guFogTableIndexToW = (void*)GetProcAddress(g3i,"_guFogTableIndexToW@4");
  if (guFogTableIndexToW == NULL)
    return 0;
  guFogGenerateExp = (void*)GetProcAddress(g3i,"_guFogGenerateExp@8");
  if (guFogGenerateExp == NULL)
    return 0;
  guFogGenerateExp2 = (void*)GetProcAddress(g3i,"_guFogGenerateExp2@8");
  if (guFogGenerateExp2 == NULL)
    return 0;
  guFogGenerateLinear = (void*)GetProcAddress(g3i,"_guFogGenerateLinear@12");
  if (guFogGenerateLinear == NULL)
    return 0;

  // hi-level texture manipulation tools.
  guGammaCorrectionRGB = (void*)GetProcAddress(g3i,"_guGammaCorrectionRGB@12");
  if (guGammaCorrectionRGB == NULL)
    return 0;

  gu3dfGetInfo = (void*)GetProcAddress(g3i,"_gu3dfGetInfo@8");
  if (gu3dfGetInfo == NULL)
    return 0;
  gu3dfLoad = (void*)GetProcAddress(g3i,"_gu3dfLoad@8");
  if (gu3dfLoad == NULL)
    return 0;

  return 1;
}

